package java.beans;

import java.io.InputStream;
import java.net.URL;
import java.applet.Applet;
import java.lang.reflect.Modifier;
import com.sun.beans.finder.ClassFinder;
import java.io.ObjectInputStream;
import java.beans.beancontext.BeanContext;
import java.io.IOException;

public class Beans
{
    public Beans() {
    }
    
    public static Object instantiate(ClassLoader classLoader, String s) throws IOException, ClassNotFoundException {
        return instantiate(classLoader, s, null, null);
    }
    
    public static Object instantiate(ClassLoader classLoader, String s, BeanContext beanContext) throws IOException, ClassNotFoundException {
        return instantiate(classLoader, s, beanContext, null);
    }
    
    public static Object instantiate(ClassLoader systemClassLoader, String name, BeanContext beanContext, AppletInitializer appletInitializer) throws IOException, ClassNotFoundException {
        Object o = null;
        boolean n = false;
        IOException ex = null;
        if (systemClassLoader == null) {
            try {
                systemClassLoader = ClassLoader.getSystemClassLoader();
            }
            catch (SecurityException ex2) {}
        }
        String concat = name.replace('.', '/').concat(".ser");
        InputStream in;
        if (systemClassLoader == null) {
            in = ClassLoader.getSystemResourceAsStream(concat);
        }
        else {
            in = systemClassLoader.getResourceAsStream(concat);
        }
        if (in != null) {
            try {
                Object o2;
                if (systemClassLoader == null) {
                    o2 = new ObjectInputStream(in);
                }
                else {
                    o2 = new ObjectInputStreamWithLoader(in, systemClassLoader);
                }
                o = o2.readObject();
                n = true;
                o2.close();
            }
            catch (IOException ex3) {
                in.close();
                ex = ex3;
            }
            catch (ClassNotFoundException ex4) {
                in.close();
                throw ex4;
            }
        }
        if (o == null) {
            Class<Object> class1;
            try {
                class1 = ClassFinder.findClass(name, systemClassLoader);
            }
            catch (ClassNotFoundException ex5) {
                if (ex != null) {
                    throw ex;
                }
                throw ex5;
            }
            if (!Modifier.isPublic(class1.getModifiers())) {
                throw new ClassNotFoundException("" + class1 + " : no public access");
            }
            try {
                o = class1.newInstance();
            }
            catch (Exception ex6) {
                throw new ClassNotFoundException("" + class1 + " : " + ex6, ex6);
            }
        }
        if (o != null) {
            Object stub = null;
            if ((o instanceof Applet)) {
                Applet applet = (Applet)o;
                int n2 = appletInitializer == null;
                if (!(n2 == 0)) {
                    String suffix;
                    if (!(n == 0)) {
                        suffix = name.replace('.', '/').concat(".ser");
                    }
                    else {
                        suffix = name.replace('.', '/').concat(".class");
                    }
                    Object o3 = null;
                    Object o4 = null;
                    URL url;
                    if (systemClassLoader == null) {
                        url = ClassLoader.getSystemResource(suffix);
                    }
                    else {
                        url = systemClassLoader.getResource(suffix);
                    }
                    if (url != null) {
                        String externalForm = url.toExternalForm();
                        if (externalForm.endsWith(suffix)) {
                            o3 = (o4 = new URL(externalForm.substring(0, externalForm.length() - suffix.length())));
                            int lastIndex = externalForm.lastIndexOf(47);
                            if (lastIndex >= 0) {
                                o4 = new URL(externalForm.substring(0, lastIndex + 1));
                            }
                        }
                    }
                    stub = new BeansAppletStub(applet, new BeansAppletContext(applet), o3, o4);
                    applet.setStub(stub);
                }
                else {
                    appletInitializer.initialize(applet, beanContext);
                }
                if (beanContext != null) {
                    unsafeBeanContextAdd(beanContext, o);
                }
                if (n == 0) {
                    applet.setSize(100, 100);
                    applet.init();
                }
                if (!(n2 == 0)) {
                    ((BeansAppletStub)stub).active = true;
                }
                else {
                    appletInitializer.activate(applet);
                }
            }
            else if (beanContext != null) {
                unsafeBeanContextAdd(beanContext, o);
            }
        }
        return o;
    }
    
    private static void unsafeBeanContextAdd(BeanContext beanContext, Object o) {
        beanContext.add(o);
    }
    
    public static Object getInstanceOf(Object o, Class<?> clazz) {
        return o;
    }
    
    public static boolean isInstanceOf(Object o, Class<?> clazz) {
        return Introspector.isSubclass(o.getClass(), clazz);
    }
    
    public static boolean isDesignTime() {
        return ThreadGroupContext.getContext().isDesignTime();
    }
    
    public static boolean isGuiAvailable() {
        return ThreadGroupContext.getContext().isGuiAvailable();
    }
    
    public static void setDesignTime(boolean designTime) throws SecurityException {
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            securityManager.checkPropertiesAccess();
        }
        ThreadGroupContext.getContext().setDesignTime(designTime);
    }
    
    public static void setGuiAvailable(boolean guiAvailable) throws SecurityException {
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null) {
            securityManager.checkPropertiesAccess();
        }
        ThreadGroupContext.getContext().setGuiAvailable(guiAvailable);
    }
}
